git-am.shon commit Merge branch 'mm/verify-filename-fix' into maint (9ca7249)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-non-patch  pass -b flag to git-mailinfo
  19keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  20no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  21c,scissors      strip everything before a scissors line
  22whitespace=     pass it through git-apply
  23ignore-space-change pass it through git-apply
  24ignore-whitespace pass it through git-apply
  25directory=      pass it through git-apply
  26exclude=        pass it through git-apply
  27include=        pass it through git-apply
  28C=              pass it through git-apply
  29p=              pass it through git-apply
  30patch-format=   format the patch(es) are in
  31reject          pass it through git-apply
  32resolvemsg=     override error message when patch failure occurs
  33continue        continue applying patches after resolving a conflict
  34r,resolved      synonyms for --continue
  35skip            skip the current patch
  36abort           restore the original branch and abort the patching operation.
  37committer-date-is-author-date    lie about committer date
  38ignore-date     use current timestamp for author date
  39rerere-autoupdate update the index with reused conflict resolution if possible
  40rebasing*       (internal use for git-rebase)"
  41
  42. git-sh-setup
  43. git-sh-i18n
  44prefix=$(git rev-parse --show-prefix)
  45set_reflog_action am
  46require_work_tree
  47cd_to_toplevel
  48
  49git var GIT_COMMITTER_IDENT >/dev/null ||
  50        die "$(gettext "You need to set your committer info first")"
  51
  52if git rev-parse --verify -q HEAD >/dev/null
  53then
  54        HAS_HEAD=yes
  55else
  56        HAS_HEAD=
  57fi
  58
  59cmdline="git am"
  60if test '' != "$interactive"
  61then
  62        cmdline="$cmdline -i"
  63fi
  64if test '' != "$threeway"
  65then
  66        cmdline="$cmdline -3"
  67fi
  68
  69sq () {
  70        git rev-parse --sq-quote "$@"
  71}
  72
  73stop_here () {
  74    echo "$1" >"$dotest/next"
  75    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  76    exit 1
  77}
  78
  79safe_to_abort () {
  80        if test -f "$dotest/dirtyindex"
  81        then
  82                return 1
  83        fi
  84
  85        if ! test -s "$dotest/abort-safety"
  86        then
  87                return 0
  88        fi
  89
  90        abort_safety=$(cat "$dotest/abort-safety")
  91        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  92        then
  93                return 0
  94        fi
  95                gettextln "You seem to have moved HEAD since the last 'am' failure.
  96Not rewinding to ORIG_HEAD" >&2
  97        return 1
  98}
  99
 100stop_here_user_resolve () {
 101    if [ -n "$resolvemsg" ]; then
 102            printf '%s\n' "$resolvemsg"
 103            stop_here $1
 104    fi
 105    eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
 106If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 107To restore the original branch and stop patching run \"\$cmdline --abort\"."
 108
 109    stop_here $1
 110}
 111
 112go_next () {
 113        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 114                "$dotest/patch" "$dotest/info"
 115        echo "$next" >"$dotest/next"
 116        this=$next
 117}
 118
 119cannot_fallback () {
 120        echo "$1"
 121        gettextln "Cannot fall back to three-way merge."
 122        exit 1
 123}
 124
 125fall_back_3way () {
 126    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 127
 128    rm -fr "$dotest"/patch-merge-*
 129    mkdir "$dotest/patch-merge-tmp-dir"
 130
 131    # First see if the patch records the index info that we can use.
 132    cmd="git apply $git_apply_opt --build-fake-ancestor" &&
 133    cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
 134    eval "$cmd" &&
 135    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 136    git write-tree >"$dotest/patch-merge-base+" ||
 137    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 138
 139    say Using index info to reconstruct a base tree...
 140
 141    cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
 142
 143    if test -z "$GIT_QUIET"
 144    then
 145        eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
 146    fi
 147
 148    cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
 149    if eval "$cmd"
 150    then
 151        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 152        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 153    else
 154        cannot_fallback "$(gettext "Did you hand edit your patch?
 155It does not apply to blobs recorded in its index.")"
 156    fi
 157
 158    test -f "$dotest/patch-merge-index" &&
 159    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 160    orig_tree=$(cat "$dotest/patch-merge-base") &&
 161    rm -fr "$dotest"/patch-merge-* || exit 1
 162
 163    say "$(gettext "Falling back to patching base and 3-way merge...")"
 164
 165    # This is not so wrong.  Depending on which base we picked,
 166    # orig_tree may be wildly different from ours, but his_tree
 167    # has the same set of wildly different changes in parts the
 168    # patch did not touch, so recursive ends up canceling them,
 169    # saying that we reverted all those changes.
 170
 171    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 172    export GITHEAD_$his_tree
 173    if test -n "$GIT_QUIET"
 174    then
 175            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 176    fi
 177    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 178            git rerere $allow_rerere_autoupdate
 179            echo Failed to merge in the changes.
 180            exit 1
 181    }
 182    unset GITHEAD_$his_tree
 183}
 184
 185clean_abort () {
 186        test $# = 0 || echo >&2 "$@"
 187        rm -fr "$dotest"
 188        exit 1
 189}
 190
 191patch_format=
 192
 193check_patch_format () {
 194        # early return if patch_format was set from the command line
 195        if test -n "$patch_format"
 196        then
 197                return 0
 198        fi
 199
 200        # we default to mbox format if input is from stdin and for
 201        # directories
 202        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 203        then
 204                patch_format=mbox
 205                return 0
 206        fi
 207
 208        # otherwise, check the first few non-blank lines of the first
 209        # patch to try to detect its format
 210        {
 211                # Start from first line containing non-whitespace
 212                l1=
 213                while test -z "$l1"
 214                do
 215                        read l1 || break
 216                done
 217                read l2
 218                read l3
 219                case "$l1" in
 220                "From "* | "From: "*)
 221                        patch_format=mbox
 222                        ;;
 223                '# This series applies on GIT commit'*)
 224                        patch_format=stgit-series
 225                        ;;
 226                "# HG changeset patch")
 227                        patch_format=hg
 228                        ;;
 229                *)
 230                        # if the second line is empty and the third is
 231                        # a From, Author or Date entry, this is very
 232                        # likely an StGIT patch
 233                        case "$l2,$l3" in
 234                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 235                                patch_format=stgit
 236                                ;;
 237                        *)
 238                                ;;
 239                        esac
 240                        ;;
 241                esac
 242                if test -z "$patch_format" &&
 243                        test -n "$l1" &&
 244                        test -n "$l2" &&
 245                        test -n "$l3"
 246                then
 247                        # This begins with three non-empty lines.  Is this a
 248                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 249                        # discarding the indented remainder of folded lines,
 250                        # and see if it looks like that they all begin with the
 251                        # header field names...
 252                        tr -d '\015' <"$1" |
 253                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 254                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 255                        patch_format=mbox
 256                fi
 257        } < "$1" || clean_abort
 258}
 259
 260split_patches () {
 261        case "$patch_format" in
 262        mbox)
 263                if test -n "$rebasing" || test t = "$keepcr"
 264                then
 265                    keep_cr=--keep-cr
 266                else
 267                    keep_cr=
 268                fi
 269                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 270                clean_abort
 271                ;;
 272        stgit-series)
 273                if test $# -ne 1
 274                then
 275                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 276                fi
 277                series_dir=`dirname "$1"`
 278                series_file="$1"
 279                shift
 280                {
 281                        set x
 282                        while read filename
 283                        do
 284                                set "$@" "$series_dir/$filename"
 285                        done
 286                        # remove the safety x
 287                        shift
 288                        # remove the arg coming from the first-line comment
 289                        shift
 290                } < "$series_file" || clean_abort
 291                # set the patch format appropriately
 292                patch_format=stgit
 293                # now handle the actual StGIT patches
 294                split_patches "$@"
 295                ;;
 296        stgit)
 297                this=0
 298                for stgit in "$@"
 299                do
 300                        this=`expr "$this" + 1`
 301                        msgnum=`printf "%0${prec}d" $this`
 302                        # Perl version of StGIT parse_patch. The first nonemptyline
 303                        # not starting with Author, From or Date is the
 304                        # subject, and the body starts with the next nonempty
 305                        # line not starting with Author, From or Date
 306                        perl -ne 'BEGIN { $subject = 0 }
 307                                if ($subject > 1) { print ; }
 308                                elsif (/^\s+$/) { next ; }
 309                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 310                                elsif (/^(From|Date)/) { print ; }
 311                                elsif ($subject) {
 312                                        $subject = 2 ;
 313                                        print "\n" ;
 314                                        print ;
 315                                } else {
 316                                        print "Subject: ", $_ ;
 317                                        $subject = 1;
 318                                }
 319                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 320                done
 321                echo "$this" > "$dotest/last"
 322                this=
 323                msgnum=
 324                ;;
 325        hg)
 326                this=0
 327                for hg in "$@"
 328                do
 329                        this=$(( $this + 1 ))
 330                        msgnum=$(printf "%0${prec}d" $this)
 331                        # hg stores changeset metadata in #-commented lines preceding
 332                        # the commit message and diff(s). The only metadata we care about
 333                        # are the User and Date (Node ID and Parent are hashes which are
 334                        # only relevant to the hg repository and thus not useful to us)
 335                        # Since we cannot guarantee that the commit message is in
 336                        # git-friendly format, we put no Subject: line and just consume
 337                        # all of the message as the body
 338                        perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 339                                if ($subject) { print ; }
 340                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 341                                elsif (/^\# Date /) {
 342                                        my ($hashsign, $str, $time, $tz) = split ;
 343                                        $tz = sprintf "%+05d", (0-$tz)/36;
 344                                        print "Date: " .
 345                                              strftime("%a, %d %b %Y %H:%M:%S ",
 346                                                       localtime($time))
 347                                              . "$tz\n";
 348                                } elsif (/^\# /) { next ; }
 349                                else {
 350                                        print "\n", $_ ;
 351                                        $subject = 1;
 352                                }
 353                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 354                done
 355                echo "$this" >"$dotest/last"
 356                this=
 357                msgnum=
 358                ;;
 359        *)
 360                if test -n "$patch_format"
 361                then
 362                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 363                else
 364                        clean_abort "$(gettext "Patch format detection failed.")"
 365                fi
 366                ;;
 367        esac
 368}
 369
 370prec=4
 371dotest="$GIT_DIR/rebase-apply"
 372sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 373resolvemsg= resume= scissors= no_inbody_headers=
 374git_apply_opt=
 375committer_date_is_author_date=
 376ignore_date=
 377allow_rerere_autoupdate=
 378
 379if test "$(git config --bool --get am.keepcr)" = true
 380then
 381    keepcr=t
 382fi
 383
 384while test $# != 0
 385do
 386        case "$1" in
 387        -i|--interactive)
 388                interactive=t ;;
 389        -b|--binary)
 390                echo >&2 "The $1 option has been a no-op for long time, and"
 391                echo >&2 "it will be removed. Please do not use it anymore."
 392                ;;
 393        -3|--3way)
 394                threeway=t ;;
 395        -s|--signoff)
 396                sign=t ;;
 397        -u|--utf8)
 398                utf8=t ;; # this is now default
 399        --no-utf8)
 400                utf8= ;;
 401        -k|--keep)
 402                keep=t ;;
 403        --keep-non-patch)
 404                keep=b ;;
 405        -c|--scissors)
 406                scissors=t ;;
 407        --no-scissors)
 408                scissors=f ;;
 409        -r|--resolved|--continue)
 410                resolved=t ;;
 411        --skip)
 412                skip=t ;;
 413        --abort)
 414                abort=t ;;
 415        --rebasing)
 416                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 417        -d|--dotest)
 418                die "$(gettext "-d option is no longer supported.  Do not use.")"
 419                ;;
 420        --resolvemsg)
 421                shift; resolvemsg=$1 ;;
 422        --whitespace|--directory|--exclude|--include)
 423                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 424        -C|-p)
 425                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 426        --patch-format)
 427                shift ; patch_format="$1" ;;
 428        --reject|--ignore-whitespace|--ignore-space-change)
 429                git_apply_opt="$git_apply_opt $1" ;;
 430        --committer-date-is-author-date)
 431                committer_date_is_author_date=t ;;
 432        --ignore-date)
 433                ignore_date=t ;;
 434        --rerere-autoupdate|--no-rerere-autoupdate)
 435                allow_rerere_autoupdate="$1" ;;
 436        -q|--quiet)
 437                GIT_QUIET=t ;;
 438        --keep-cr)
 439                keepcr=t ;;
 440        --no-keep-cr)
 441                keepcr=f ;;
 442        --)
 443                shift; break ;;
 444        *)
 445                usage ;;
 446        esac
 447        shift
 448done
 449
 450# If the dotest directory exists, but we have finished applying all the
 451# patches in them, clear it out.
 452if test -d "$dotest" &&
 453   last=$(cat "$dotest/last") &&
 454   next=$(cat "$dotest/next") &&
 455   test $# != 0 &&
 456   test "$next" -gt "$last"
 457then
 458   rm -fr "$dotest"
 459fi
 460
 461if test -d "$dotest"
 462then
 463        case "$#,$skip$resolved$abort" in
 464        0,*t*)
 465                # Explicit resume command and we do not have file, so
 466                # we are happy.
 467                : ;;
 468        0,)
 469                # No file input but without resume parameters; catch
 470                # user error to feed us a patch from standard input
 471                # when there is already $dotest.  This is somewhat
 472                # unreliable -- stdin could be /dev/null for example
 473                # and the caller did not intend to feed us a patch but
 474                # wanted to continue unattended.
 475                test -t 0
 476                ;;
 477        *)
 478                false
 479                ;;
 480        esac ||
 481        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 482        resume=yes
 483
 484        case "$skip,$abort" in
 485        t,t)
 486                die "$(gettext "Please make up your mind. --skip or --abort?")"
 487                ;;
 488        t,)
 489                git rerere clear
 490                git read-tree --reset -u HEAD HEAD
 491                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 492                git reset HEAD
 493                git update-ref ORIG_HEAD $orig_head
 494                ;;
 495        ,t)
 496                if test -f "$dotest/rebasing"
 497                then
 498                        exec git rebase --abort
 499                fi
 500                git rerere clear
 501                if safe_to_abort
 502                then
 503                        git read-tree --reset -u HEAD ORIG_HEAD
 504                        git reset ORIG_HEAD
 505                fi
 506                rm -fr "$dotest"
 507                exit ;;
 508        esac
 509        rm -f "$dotest/dirtyindex"
 510else
 511        # Make sure we are not given --skip, --resolved, nor --abort
 512        test "$skip$resolved$abort" = "" ||
 513                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 514
 515        # Start afresh.
 516        mkdir -p "$dotest" || exit
 517
 518        if test -n "$prefix" && test $# != 0
 519        then
 520                first=t
 521                for arg
 522                do
 523                        test -n "$first" && {
 524                                set x
 525                                first=
 526                        }
 527                        if is_absolute_path "$arg"
 528                        then
 529                                set "$@" "$arg"
 530                        else
 531                                set "$@" "$prefix$arg"
 532                        fi
 533                done
 534                shift
 535        fi
 536
 537        check_patch_format "$@"
 538
 539        split_patches "$@"
 540
 541        # -i can and must be given when resuming; everything
 542        # else is kept
 543        echo " $git_apply_opt" >"$dotest/apply-opt"
 544        echo "$threeway" >"$dotest/threeway"
 545        echo "$sign" >"$dotest/sign"
 546        echo "$utf8" >"$dotest/utf8"
 547        echo "$keep" >"$dotest/keep"
 548        echo "$scissors" >"$dotest/scissors"
 549        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 550        echo "$GIT_QUIET" >"$dotest/quiet"
 551        echo 1 >"$dotest/next"
 552        if test -n "$rebasing"
 553        then
 554                : >"$dotest/rebasing"
 555        else
 556                : >"$dotest/applying"
 557                if test -n "$HAS_HEAD"
 558                then
 559                        git update-ref ORIG_HEAD HEAD
 560                else
 561                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 562                fi
 563        fi
 564fi
 565
 566git update-index -q --refresh
 567
 568case "$resolved" in
 569'')
 570        case "$HAS_HEAD" in
 571        '')
 572                files=$(git ls-files) ;;
 573        ?*)
 574                files=$(git diff-index --cached --name-only HEAD --) ;;
 575        esac || exit
 576        if test "$files"
 577        then
 578                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 579                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 580        fi
 581esac
 582
 583# Now, decide what command line options we will give to the git
 584# commands we invoke, based on the result of parsing command line
 585# options and previous invocation state stored in $dotest/ files.
 586
 587if test "$(cat "$dotest/utf8")" = t
 588then
 589        utf8=-u
 590else
 591        utf8=-n
 592fi
 593keep=$(cat "$dotest/keep")
 594case "$keep" in
 595t)
 596        keep=-k ;;
 597b)
 598        keep=-b ;;
 599*)
 600        keep= ;;
 601esac
 602case "$(cat "$dotest/scissors")" in
 603t)
 604        scissors=--scissors ;;
 605f)
 606        scissors=--no-scissors ;;
 607esac
 608if test "$(cat "$dotest/no_inbody_headers")" = t
 609then
 610        no_inbody_headers=--no-inbody-headers
 611else
 612        no_inbody_headers=
 613fi
 614if test "$(cat "$dotest/quiet")" = t
 615then
 616        GIT_QUIET=t
 617fi
 618if test "$(cat "$dotest/threeway")" = t
 619then
 620        threeway=t
 621fi
 622git_apply_opt=$(cat "$dotest/apply-opt")
 623if test "$(cat "$dotest/sign")" = t
 624then
 625        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 626                        s/>.*/>/
 627                        s/^/Signed-off-by: /'
 628                `
 629else
 630        SIGNOFF=
 631fi
 632
 633last=`cat "$dotest/last"`
 634this=`cat "$dotest/next"`
 635if test "$skip" = t
 636then
 637        this=`expr "$this" + 1`
 638        resume=
 639fi
 640
 641while test "$this" -le "$last"
 642do
 643        msgnum=`printf "%0${prec}d" $this`
 644        next=`expr "$this" + 1`
 645        test -f "$dotest/$msgnum" || {
 646                resume=
 647                go_next
 648                continue
 649        }
 650
 651        # If we are not resuming, parse and extract the patch information
 652        # into separate files:
 653        #  - info records the authorship and title
 654        #  - msg is the rest of commit log message
 655        #  - patch is the patch body.
 656        #
 657        # When we are resuming, these files are either already prepared
 658        # by the user, or the user can tell us to do so by --resolved flag.
 659        case "$resume" in
 660        '')
 661                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 662                        <"$dotest/$msgnum" >"$dotest/info" ||
 663                        stop_here $this
 664
 665                # skip pine's internal folder data
 666                sane_grep '^Author: Mail System Internal Data$' \
 667                        <"$dotest"/info >/dev/null &&
 668                        go_next && continue
 669
 670                test -s "$dotest/patch" || {
 671                        eval_gettextln "Patch is empty.  Was it split wrong?
 672If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 673To restore the original branch and stop patching run \"\$cmdline --abort\"."
 674                        stop_here $this
 675                }
 676                rm -f "$dotest/original-commit" "$dotest/author-script"
 677                if test -f "$dotest/rebasing" &&
 678                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 679                                -e q "$dotest/$msgnum") &&
 680                        test "$(git cat-file -t "$commit")" = commit
 681                then
 682                        git cat-file commit "$commit" |
 683                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 684                        echo "$commit" > "$dotest/original-commit"
 685                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 686                else
 687                        {
 688                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 689                                echo
 690                                cat "$dotest/msg"
 691                        } |
 692                        git stripspace > "$dotest/msg-clean"
 693                fi
 694                ;;
 695        esac
 696
 697        if test -f "$dotest/author-script"
 698        then
 699                eval $(cat "$dotest/author-script")
 700        else
 701                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 702                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 703                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 704        fi
 705
 706        if test -z "$GIT_AUTHOR_EMAIL"
 707        then
 708                gettextln "Patch does not have a valid e-mail address."
 709                stop_here $this
 710        fi
 711
 712        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 713
 714        case "$resume" in
 715        '')
 716            if test '' != "$SIGNOFF"
 717            then
 718                LAST_SIGNED_OFF_BY=`
 719                    sed -ne '/^Signed-off-by: /p' \
 720                    "$dotest/msg-clean" |
 721                    sed -ne '$p'
 722                `
 723                ADD_SIGNOFF=`
 724                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 725                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 726                    echo "$SIGNOFF"
 727                }`
 728            else
 729                ADD_SIGNOFF=
 730            fi
 731            {
 732                if test -s "$dotest/msg-clean"
 733                then
 734                        cat "$dotest/msg-clean"
 735                fi
 736                if test '' != "$ADD_SIGNOFF"
 737                then
 738                        echo "$ADD_SIGNOFF"
 739                fi
 740            } >"$dotest/final-commit"
 741            ;;
 742        *)
 743                case "$resolved$interactive" in
 744                tt)
 745                        # This is used only for interactive view option.
 746                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 747                        ;;
 748                esac
 749        esac
 750
 751        resume=
 752        if test "$interactive" = t
 753        then
 754            test -t 0 ||
 755            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 756            action=again
 757            while test "$action" = again
 758            do
 759                gettextln "Commit Body is:"
 760                echo "--------------------------"
 761                cat "$dotest/final-commit"
 762                echo "--------------------------"
 763                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 764                # in your translation. The program will only accept English
 765                # input at this point.
 766                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 767                read reply
 768                case "$reply" in
 769                [yY]*) action=yes ;;
 770                [aA]*) action=yes interactive= ;;
 771                [nN]*) action=skip ;;
 772                [eE]*) git_editor "$dotest/final-commit"
 773                       action=again ;;
 774                [vV]*) action=again
 775                       git_pager "$dotest/patch" ;;
 776                *)     action=again ;;
 777                esac
 778            done
 779        else
 780            action=yes
 781        fi
 782
 783        if test -f "$dotest/final-commit"
 784        then
 785                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 786        else
 787                FIRSTLINE=""
 788        fi
 789
 790        if test $action = skip
 791        then
 792                go_next
 793                continue
 794        fi
 795
 796        if test -x "$GIT_DIR"/hooks/applypatch-msg
 797        then
 798                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 799                stop_here $this
 800        fi
 801
 802        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 803
 804        case "$resolved" in
 805        '')
 806                # When we are allowed to fall back to 3-way later, don't give
 807                # false errors during the initial attempt.
 808                squelch=
 809                if test "$threeway" = t
 810                then
 811                        squelch='>/dev/null 2>&1 '
 812                fi
 813                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 814                apply_status=$?
 815                ;;
 816        t)
 817                # Resolved means the user did all the hard work, and
 818                # we do not have to do any patch application.  Just
 819                # trust what the user has in the index file and the
 820                # working tree.
 821                resolved=
 822                git diff-index --quiet --cached HEAD -- && {
 823                        gettextln "No changes - did you forget to use 'git add'?
 824If there is nothing left to stage, chances are that something else
 825already introduced the same changes; you might want to skip this patch."
 826                        stop_here_user_resolve $this
 827                }
 828                unmerged=$(git ls-files -u)
 829                if test -n "$unmerged"
 830                then
 831                        gettextln "You still have unmerged paths in your index
 832did you forget to use 'git add'?"
 833                        stop_here_user_resolve $this
 834                fi
 835                apply_status=0
 836                git rerere
 837                ;;
 838        esac
 839
 840        if test $apply_status != 0 && test "$threeway" = t
 841        then
 842                if (fall_back_3way)
 843                then
 844                    # Applying the patch to an earlier tree and merging the
 845                    # result may have produced the same tree as ours.
 846                    git diff-index --quiet --cached HEAD -- && {
 847                        say "$(gettext "No changes -- Patch already applied.")"
 848                        go_next
 849                        continue
 850                    }
 851                    # clear apply_status -- we have successfully merged.
 852                    apply_status=0
 853                fi
 854        fi
 855        if test $apply_status != 0
 856        then
 857                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 858                stop_here_user_resolve $this
 859        fi
 860
 861        if test -x "$GIT_DIR"/hooks/pre-applypatch
 862        then
 863                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 864        fi
 865
 866        tree=$(git write-tree) &&
 867        commit=$(
 868                if test -n "$ignore_date"
 869                then
 870                        GIT_AUTHOR_DATE=
 871                fi
 872                parent=$(git rev-parse --verify -q HEAD) ||
 873                say >&2 "$(gettext "applying to an empty history")"
 874
 875                if test -n "$committer_date_is_author_date"
 876                then
 877                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 878                        export GIT_COMMITTER_DATE
 879                fi &&
 880                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 881        ) &&
 882        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 883        stop_here $this
 884
 885        if test -f "$dotest/original-commit"; then
 886                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 887        fi
 888
 889        if test -x "$GIT_DIR"/hooks/post-applypatch
 890        then
 891                "$GIT_DIR"/hooks/post-applypatch
 892        fi
 893
 894        go_next
 895done
 896
 897if test -s "$dotest"/rewritten; then
 898    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 899    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 900        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 901    fi
 902fi
 903
 904rm -fr "$dotest"
 905git gc --auto